
(define doc-styles #t)
(define page-styles #t)
(define column-styles #t)
(define line-styles-low #t)
(define line-styles-high #t)
(define line-styles-center #t)
(define line-styles-fill #t)
(define word-styles #t)
(define wordsegment-styles #t)
(define tag-styles #t);
(define local-wordsegment-styles #t)

(define all-styles #t)

(define highlight-start #t)
(define highlight #t)
(define highlight-end #t)

(define cur-attr #t)
(define cur-tag-attr #t)



(define (create-attributes-i attrs)
  (let ((new-attributes (attributes.new)))
    (do ((at attrs (cdr at)))
	((null? at) new-attributes)
      (attributes.add-i new-attributes (car (car at)) (cadr (car at))))))


(define (create-empty-doc xd)
  (let* ((fm (xdisplay.get-fm xd))
	 (f0 (fontmanager.defaultFont fm))
	 (f1 (fontmanager.query fm "Courier:16"))
	 (f2 (fontmanager.query fm "Courier:24"))
	 ;
	 (xdisplay (xdisplay.get-display xd))
	 ;
	 (cmap (xt-default-colormap xdisplay))
	 (color-white (xt-new-xcolor))
	 (color-black (xt-new-xcolor))
	 (color-green (xt-new-xcolor))
	 (color-green4 (xt-new-xcolor))
	 (color-red (xt-new-xcolor))
	 (color-hl-grey (xt-new-xcolor))
	 ;
	 (doc #t)
	 )
    (xt-parse-color xdisplay cmap "white" color-white)
    (xt-alloc-color xdisplay cmap color-white);
    (xt-parse-color xdisplay cmap "black" color-black)
    (xt-alloc-color xdisplay cmap color-black);
    (xt-parse-color xdisplay cmap "green" color-green)
    (xt-alloc-color xdisplay cmap color-green);
    (xt-parse-color xdisplay cmap "green4" color-green4)
    (xt-alloc-color xdisplay cmap color-green4);
    (xt-parse-color xdisplay cmap "red" color-red)
    (xt-alloc-color xdisplay cmap color-red);
    ;(xt-parse-color xdisplay cmap "grey40" color-hl-grey)
    (xt-parse-color xdisplay cmap "green4" color-hl-grey)
    (xt-alloc-color xdisplay cmap color-hl-grey);

    ; for document
    (set! doc-styles
	  (list
	   (create-attributes-i
	    (list (list at-fill-style FS-low)
		  (list at-direction DIR-ud)
		  (list at-overflow-policy OP-push-to-next)
		  (list at-background (xt-xcolor-pixel color-black))
		  (list at-foreground (xt-xcolor-pixel color-white))))))

    ; for page
    (set! page-styles
	  (list
	   (create-attributes-i
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right
		   ;(* magnify 432)
		   (* magnify 433)
		   )))))


    ; for columns
    (set! column-styles
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; latin, 2 columns
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-left (* magnify 432))))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))))


    ; for lines
    (set! line-styles-low
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 432))))
	   (create-attributes-i ; latin, 2 column
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 216))))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-left (* magnify 432))))))

    (set! line-styles-center
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-center)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 432))))
	   (create-attributes-i ; latin, 2 column
	    (list
	     (list at-fill-style FS-center)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 216))))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-center)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-center)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-left (* magnify 432))))))

    (set! line-styles-high
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-high)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 432))))
	   (create-attributes-i ; latin, 2 column
	    (list
	     (list at-fill-style FS-high)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 216))))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-high)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-high)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-left (* magnify 432))))))

    (set! line-styles-fill
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-fill)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 432))))
	   (create-attributes-i ; latin, 2 column
	    (list
	     (list at-fill-style FS-fill)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-right (* magnify 216))))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-fill)
	     (list at-direction DIR-ud)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-down (* magnify 648))))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-fill)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-push-to-next)
	     (list at-fixed-left (* magnify 432))))))


    ; for words
    (set! word-styles
	  (list
	   (create-attributes-i ; latin
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-create-a-new-container)))
	   (create-attributes-i ; latin, 2 column
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-lr)
	     (list at-overflow-policy OP-create-a-new-container)))
	   (create-attributes-i ; asian
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-create-a-new-container)))
	   (create-attributes-i ; arabic
	    (list
	     (list at-fill-style FS-low)
	     (list at-direction DIR-rl)
	     (list at-overflow-policy OP-create-a-new-container)))))



    ; for wordsegments
    (set! wordsegment-styles
	  (list
	   (create-attributes-i
	    (list
	     (list at-font f0)))
	   (create-attributes-i
	    (list
	     (list at-font f1)
	     ;(list at-foreground (xt-xcolor-pixel color-green))
	     ))
	   (create-attributes-i
	    (list
	     (list at-font f2)
	     ;(list at-background (xt-xcolor-pixel color-green4))
	     ))))


    ; for tags
    (set! tag-styles
	  (list
	   (create-attributes-i
	    (list
	     (list at-foreground (xt-xcolor-pixel color-green4))))
	   (create-attributes-i
	    (list
	     (list at-foreground (xt-xcolor-pixel color-green4))))))


    (set! all-styles (append doc-styles
			     page-styles
			     column-styles
			     line-styles-low
			     line-styles-high
			     line-styles-center
			     line-styles-fill
			     word-styles
			     wordsegment-styles
			     tag-styles))

    (set! local-wordsegment-styles (list))

    (set! highlight-start
	  (create-attributes-i
	   (list
	    (list at-background (xt-xcolor-pixel color-hl-grey))
	    (list at-hl-start 0)
	    )))

    (set! highlight
	  (create-attributes-i
	   (list
	    (list at-background (xt-xcolor-pixel color-hl-grey))
	    )))

    (set! highlight-end
	  (create-attributes-i
	   (list
	    (list at-background (xt-xcolor-pixel color-hl-grey))
	    (list at-hl-end 0)
	    )))

    (set! cur-attr (car wordsegment-styles))
    (set! cur-tag-attr (cadr tag-styles))

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; build a default empty document...
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (let* ((doc-style (car doc-styles))
	   (page-style (car page-styles))
	   (column-style (car column-styles))
	   (line-style (car line-styles-low))
	   (word-style (car word-styles))
	   (wordsegment-style (car wordsegment-styles)))

      (set! doc (document.new doc-style))

      (container.insert-child (container.last-lowest-container doc) 0
			      (page.new page-style))

      (container.insert-child (container.last-lowest-container doc) 0
			      (container.new column-style))
      
      (container.insert-child (container.last-lowest-container doc) 0
			      (container.new line-style))
      
      (container.insert-child (container.last-lowest-container doc) 0
			      (container.new word-style))
      
      (container.insert-child (container.last-lowest-container doc) 0
			      (wordsegment.new wordsegment-style)))

    doc))


(define (find-wordsegment-style font-name font-size
				;background-color font-color
				)
  (let* ((num (length wordsegment-styles))
	 (i (do ((i 0 (+ i 1)))
		((or (>= i num)
		     (let* ((nth (list-ref wordsegment-styles i))
			    (font (attributes.get-i nth at-font))
			    (name (vk-font.display-name font))
			    (size (vk-font.point-size font)))
		       ;(display "checking --> ")
		       ;(display name)
		       ;(display ":")
		       ;(display size)
		       ;(newline)
		       (and (string=? name font-name)
			    (eqv? size font-size))))
		 i))))

    (if (< i num)
	; found it.
	(list-ref wordsegment-styles i)
	; didn't find it -- make a new one
	(let* ((n (string-append font-name ":" (number->string font-size)))
	       (new-font (fontmanager.query fm n))
	       (new-attr (create-attributes-i
			  (list
			   (list at-font new-font))))
	       )
	  ;(display "need to make a new wordsegment style: ")
	  ;(display font-name)
	  ;(display ":")
	  ;(display font-size)
	  ;(newline)

	  (set! wordsegment-styles
		(list-append wordsegment-styles (list new-attr)))

	  (set! all-styles
		(list-append all-styles (list new-attr)))

	  (set! local-wordsegment-styles
		(list-append local-wordsegment-styles (list new-attr)))

	  new-attr))))
