
(define to-ispell 0)
(define from-ispell 0)
(define ispell-child-pid 0)

(define ispell-shell #f)
(define ispell-form #f)
(define ispell-list #f)
(define ispell-tf #f)

(define ispell-replace #f)
(define ispell-ignore #f)
(define ispell-accept #f)
(define ispell-add #f)
(define ispell-close #f)


(define ispell-resp-done #t)
(define ispell-offset #f)
(define ispell-end #f)
(define ispell-txt #f)
(define ispell-od 0) ;offset diff


(define (open-ispell)

  (let* ((can-save #t)
	 (handler (lambda (key args . rest) (set! can-save #f) key))
	 (blah (catch #t (lambda () (actually-open-ispell)) handler)))

    (cond ((eq? can-save #f)
	   (display "There has been some trouble with ispell.") (newline)
	   (display "Is it in your path?") (newline)
	   (display "exception: ")
	   (display blah) (newline)
	   #f)
	  (else #t))))


(define (actually-open-ispell)
  (if (<= ispell-child-pid 0)
      (let* ((stdin (car (fdes->ports 0)))
	     (stdout (car (fdes->ports 1)))
	     (stderr (car (fdes->ports 2)))
	     (p-guile-dc (pipe))
	     (p-dc-guile (pipe))
	     (dg1 (cdr p-dc-guile))
	     (gd1 (car p-guile-dc)))
	(set! to-ispell (cdr p-guile-dc))
	(set! from-ispell (car p-dc-guile))

	(set! ispell-child-pid (primitive-fork))

	(if (eqv? 0 ispell-child-pid)
	    (begin
	      (redirect-port gd1 stdin)
	      (redirect-port dg1 stdout)

	      (let* ((can-save #t)
		     (handler (lambda (key args . rest)
				(set! can-save #f) key))
		     (blah (catch
			    #t
			    (lambda ()
			      (execlp "ispell" "ispell" "-a"))
			    handler)))
		(cond ((eq? can-save #f)
		       (display "ispell exec error" dg1)
		       (close-port gd1)
		       (close-port dg1)
		       (quit))))))

	(close-port gd1)
	(close-port dg1)
	
	;wait for and display ispell's greeting
	;(display (read-line from-ispell)) (newline)))

	(let ((greet (read-line from-ispell)))
	  (if (string=? greet "ispell exec error")
	      (begin
		
		(error "couldn't exec ispell"))
	      (begin
		(display greet)
		(newline)
		(continue-open-ispell)))))))

(define (continue-open-ispell)
  ; open the windows
  (if (eqv? ispell-shell #f)
      (begin
	(set! ispell-shell (xt-app-create-shell xdisplay "ispell"))
	(set! ispell-form
	      (xt-create-widget "ispell form"
				(xm-form-widget-class) ispell-shell #f))
	(set! ispell-list
	      (xm-create-scrolled-list ispell-form
				       "ispell list"
				       (list (list (xm-n-left-attachment)
						   (xm-attach-form))
					     (list (xm-n-top-attachment)
						   (xm-attach-form))
					     (list (xm-n-right-attachment)
						   (xm-attach-form))
					     (list (xm-n-bottom-attachment)
						   (xm-attach-none))
					     (list (xm-n-visible-item-count)
						   5))))
	(set! ispell-tf
	      (xt-create-widget "ispell tf"
				(xm-text-field-widget-class)
				ispell-form
				(list (list (xm-n-left-attachment)
					    (xm-attach-form))
				      (list (xm-n-top-attachment)
					    (xm-attach-widget))
				      (list (xm-n-top-widget)
					    ispell-list)
				      (list (xm-n-right-attachment)
					    (xm-attach-form))
				      (list (xm-n-columns)
					    30)
				      (list (xm-n-bottom-attachment)
					    (xm-attach-none)))))


	(set! ispell-replace
	      (xt-create-widget
	       "replace"
	       (xm-push-button-widget-class)
	       ispell-form
	       (list (list (xm-n-left-attachment) (xm-attach-form))
		     (list (xm-n-top-attachment) (xm-attach-widget))
		     (list (xm-n-top-widget) ispell-tf)
		     (list (xm-n-right-attachment) (xm-attach-none))
		     (list (xm-n-bottom-attachment) (xm-attach-form)))))
	(set! ispell-ignore
	      (xt-create-widget
	       "ignore"
	       (xm-push-button-widget-class)
	       ispell-form
	       (list (list (xm-n-left-attachment) (xm-attach-widget))
		     (list (xm-n-left-widget) ispell-replace)
		     (list (xm-n-top-attachment) (xm-attach-widget))
		     (list (xm-n-top-widget) ispell-tf)
		     (list (xm-n-right-attachment) (xm-attach-none))
		     (list (xm-n-bottom-attachment) (xm-attach-form)))))
	(set! ispell-accept
	      (xt-create-widget
	       "accept"
	       (xm-push-button-widget-class)
	       ispell-form
	       (list (list (xm-n-left-attachment) (xm-attach-widget))
		     (list (xm-n-left-widget) ispell-ignore)
		     (list (xm-n-top-attachment) (xm-attach-widget))
		     (list (xm-n-top-widget) ispell-tf)
		     (list (xm-n-right-attachment) (xm-attach-none))
		     (list (xm-n-bottom-attachment) (xm-attach-form)))))
	(set! ispell-add
	      (xt-create-widget
	       "add"
	       (xm-push-button-widget-class)
	       ispell-form
	       (list (list (xm-n-left-attachment) (xm-attach-widget))
		     (list (xm-n-left-widget) ispell-accept)
		     (list (xm-n-top-attachment) (xm-attach-widget))
		     (list (xm-n-top-widget) ispell-tf)
		     (list (xm-n-right-attachment) (xm-attach-none))
		     (list (xm-n-bottom-attachment) (xm-attach-form)))))
	(set! ispell-close
	      (xt-create-widget
	       "close"
	       (xm-push-button-widget-class)
	       ispell-form
	       (list (list (xm-n-left-attachment) (xm-attach-widget))
		     (list (xm-n-left-widget) ispell-add)
		     (list (xm-n-top-attachment) (xm-attach-widget))
		     (list (xm-n-top-widget) ispell-tf)
		     (list (xm-n-right-attachment) (xm-attach-none))
		     (list (xm-n-bottom-attachment) (xm-attach-form)))))

	(xt-add-callback ispell-list
			 (xm-n-browse-selection-callback)
			 ispell-list-callback
			 (list #t))

	(xt-add-callback ispell-replace
			 (xm-n-activate-callback)
			 ispell-replace-callback
			 (list #t))

	(xt-add-callback ispell-ignore
			 (xm-n-activate-callback)
			 ispell-ignore-callback
			 (list #t))

	(xt-add-callback ispell-close
			 (xm-n-activate-callback)
			 close-ispell-callback
			 (list #t))


	(xt-manage-child ispell-list)
	(xt-manage-child ispell-form)
	(xt-manage-child ispell-tf)
	(xt-manage-child ispell-replace)
	(xt-manage-child ispell-ignore)
	(xt-manage-child ispell-accept)
	(xt-manage-child ispell-add)
	(xt-manage-child ispell-close)
	(xt-realize-widget ispell-shell)))
  (xt-popup ispell-shell (xt-grab-none))
  (xm-list-delete-all-items ispell-list)
  )


(define (ispell-list-callback widget client-data call-data)
  (let* ((sp (xt-get-value ispell-list (xm-n-selected-items)))
	 (s (dereference sp))
	 (str (xm-string-get-l-to-r s (xm-font-list-default-tag)))
	 (c-str (scm-string-to-c-string str)))
    (xt-set-value ispell-tf (xm-n-value) c-str)
    ))


(define (ispell-replace-callback widget client-data call-data)
  (xword-window.unhighlight xw)
  (xm-list-delete-all-items ispell-list)
  (let* ((c-str (xt-get-value ispell-tf (xm-n-value)))
	 (str (c-string-to-scm-string c-str))
	 (new-leaf (string-append
		    (substring ispell-txt 0 ispell-offset)
		    str
		    (substring ispell-txt ispell-end
			       (length ispell-txt))))
	 )
    ; when a wordsegment has more than one word in it,
    ; and the first one gets replaced with a new word
    ; of a different length, there is a discrepancy
    ; between ispell's idea of the start of the next word,
    ; and the start of the next word in ispell-txt.
    ; ispell-od (offset diff) keeps track of the change
    (set! ispell-od (+ ispell-od (- (length str)
				    (- ispell-end ispell-offset))))

    ;(display "replacing with ") (display str) (newline)
    ;(display "               ") (display new-leaf) (newline)
    
    (set! ispell-txt new-leaf)
    ;(set! ispell-cur (xword-window.set-leaf-ascii xw ispell-cur new-leaf))

    (let* ((point (get-point xw))
	   (prev (container.prev-node point)))
      (container.set-leaf-ascii point new-leaf)
      (if (eqv? #f prev)
	  (xword-window.rewrap xw point point)
	  (xword-window.rewrap xw prev point)))

    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw doc)

    ;(display "----------------------------") (newline)
    ;(display "ispell-od: ") (display ispell-od) (newline)
    ;(display "ispell-txt: ") (display ispell-txt) (newline)

    (ispell-check-from-slab)
    ))
  

(define (ispell-ignore-callback widget client-data call-data)
  (xword-window.unhighlight xw)
  (xm-list-delete-all-items ispell-list)
  (ispell-check-from-slab))


(define (run-ispell)
  (if (open-ispell)
      (ispell-check-from-slab)))


(define (ispell-check-from-slab)
  ;(display "start of check-from-slab") (newline)
  (do ((ispell-pause #f)
       (ispell-end-reached #f))
      ((eqv? ispell-pause #t) #t)
    ;
    (if (eqv? ispell-end-reached #f)
	(begin
	  (if (eqv? ispell-resp-done #t) ; send a new wordsegment
	      (begin
		(set! ispell-txt (container.get-leaf-ascii (get-point xw)))
		;(display ispell-txt) (newline) ;;; debugging

		; avoid any of ispell's command characters
		(set! ispell-od
		      (do ((i 0 (+ i 1)))
			  ((or (eqv? i (length ispell-txt))
			       (let ((c (string-ref ispell-txt i)))
				 (and (not (char=? c #\*))
				      (not (char=? c #\@))
				      (not (char=? c #\#))
				      (not (char=? c #\~))
				      (not (char=? c #\+))
				      (not (char=? c #\-))
				      (not (char=? c #\!))
				      (not (char=? c #\%))
				      (not (char=? c #\^))))) i)
			#t))


		(if (and (> (length ispell-txt) 0)
			 (or (char=? (string-ref ispell-txt
						 (- (length ispell-txt) 1))
				     #\newline)
			     (char=? (string-ref ispell-txt
						 (- (length ispell-txt) 1))
				     #\015)))
		    (write-line
		     (substring ispell-txt ispell-od
				(- (length ispell-txt) 1))
		     to-ispell)
		    (write-line
		     (substring ispell-txt ispell-od (length ispell-txt))
		     to-ispell)
		    )

		(force-output to-ispell)
		(set! ispell-resp-done #f)))
	  (let* ((resp (read-line from-ispell)))
	    (if (eqv? (length resp) 0)
		(let ((new-point (container.next-node (get-point xw))))
		  ;next word
		  (set! ispell-resp-done #t)
		  (if (eqv? new-point #f)
		      (set! ispell-end-reached #t)
		      (set-point xw new-point)))
		(let ((f (string-ref resp 0))) ; parse response
		  (cond
		   ((char=? f #\*) ;(display "  OK") (newline)
				   )
		   ((char=? f #\+) ;(display "  root") (newline)
		    )
		   ((char=? f #\-) ;(display "  compound") (newline)
		    )
		   ((or (char=? f #\&)
			(char=? f #\?))
		    ;(display "  miss or guess") (newline)
		    (ispell-list-add-guesses resp)
		    (xword-window.set-mark-position xw (get-point xw)
						    ispell-offset)
		    (xword-window.set-cursor-position xw (get-point xw)
						      ispell-end)
		    (hl-point-to-mark)
		    (xword-window.scroll-to-cursor xw)
		    (xword-window.redraw xw doc)
		    (set! ispell-pause #t))
		   ((char=? f #\#)
		    ;(display "  none") (newline)
		    (ispell-list-parse-none resp)
		    (xword-window.set-mark-position xw (get-point xw)
						    ispell-offset)
		    (xword-window.set-cursor-position xw (get-point xw)
						      ispell-end)
		    (hl-point-to-mark)
		    (xword-window.scroll-to-cursor xw)
		    (xword-window.redraw xw doc)
		    (set! ispell-pause #t))
		   ) ; end of cond
		  ) ; end of let
		) ; end of if
	    ) ; end of let*
	  ) ; end of begin
	(begin ; else end of doc is reached
	  (set! ispell-pause #t)
	  (close-ispell)
	  )
	) ; end of if
    ) ; end of do
  ;(display "end of check-from-slab") (newline)
  ) ; end of define


(define (ispell-list-parse-none resp)
  (let* ((original-end (char-index resp 2 #\Space))
	 (original (substring resp 2 original-end))
	 (offset-start (+ original-end 1))
	 (offset-end (length resp))
	 (offset (substring resp offset-start offset-end)))
    ;(display "none: ") (newline)
    ;(display "   parsing: ") (display resp) (newline)
    ;(display "  original: ") (display original) (newline)
    ;(display "    offset: ") (display offset) (newline)
    (set! ispell-offset (+ (string->number offset) ispell-od))
    (set! ispell-end ; find the end of this word
	  (do ((end ispell-offset (+ end 1)))
	      ((or (eqv? end (length ispell-txt))
		   (not (char-alphabetic? (string-ref ispell-txt end))))
	       end)))
    (ispell-set-tf original)))


(define (ispell-list-add-guesses resp)
  (let* ((original-end (char-index resp 2 #\Space))
	 (original (substring resp 2 original-end))
	 ;(original-c (scm-string-to-c-string original))
	 (count-start (+ original-end 1))
	 (count-end (char-index resp count-start #\Space))
	 (offset-start (+ count-end 1))
	 (offset-end (char-index resp offset-start #\:))
	 (offset (substring resp offset-start offset-end))
	 (len (length resp))
	 )
    ;(display "guess: ") (newline)
    ;(display "   parsing: ") (display resp) (newline)
    ;(display "  original: ") (display original) (newline)
    ;(display "    offset: ") (display offset) (newline)
    (set! ispell-offset (+ (string->number offset) ispell-od))
    (set! ispell-end ; find the end of this word
	  (do ((end ispell-offset (+ end 1)))
	      ((or (eqv? end (length ispell-txt))
		   (not (char-alphabetic? (string-ref ispell-txt end))))
	       end)))

    (ispell-set-tf original)

    (do ((start (+ offset-end 2) (+ end 2))
	 (end (char-index resp (+ offset-end 2) #\,)
	      (char-index resp (+ end 2) #\,)))
	((eqv? end #f)
	 (if (< start len)
	     (ispell-list-add-word (substring resp start len))))
      (ispell-list-add-word (substring resp start end)))))


(define (ispell-set-tf str)
  (let* ((str-c (scm-string-to-c-string str)))
    (xt-set-value ispell-tf (xm-n-value) str-c)
    ; free str-c? FIX ME
    ))


(define (ispell-list-add-word word)
  (let* ((word-str (xm-string-create-localized word)))
    (xm-list-add-item ispell-list word-str 0)
    (xm-string-free word-str)))


(define (close-ispell)
  (if (> ispell-child-pid 0)
      (begin
	(xword-window.unhighlight xw)
	(close-port to-ispell)
	(close-port from-ispell)
	(kill ispell-child-pid SIGHUP)
	(set! ispell-child-pid 0)
	(xt-popdown ispell-shell)
	;(set! ispell-cur #f)
	(set! ispell-resp-done #t))))

(define (close-ispell-callback widget client-data call-data)
  (close-ispell))
