;; (load-from-path "scsh/init")

(define combos-on #t)
(define magnify 1.5)


(load (find-the-file "ispell.scm"))
(load (find-the-file "motif.scm"))
(load (find-the-file "empty_doc.scm"))
(load (find-the-file "file-io-xword.scm"))
(load (find-the-file "file-io-ascii.scm"))
(load (find-the-file "file-io-ps.scm"))
(load (find-the-file "file-io-img.scm"))
(load (find-the-file "file-io-html.scm"))
(load (find-the-file "xkeysym.scm"))
(load (find-the-file "keyprocs.scm"))
(load (find-the-file "cut-paste.scm"))
(load (find-the-file "search.scm"))


;;;;;;;;;;;;;;;;;;;;;
;; X callback stuff
;;;;;;;;;;;;;;;;;;;;;


(define (menuF widget client-data call-data)
  (display "unimplemented menu callback: ")
  (display client-data)
  (newline))

;;;;;;;;;;;;;;;;;;;;;;;;
;; file menu callbacks
;;;;;;;;;;;;;;;;;;;;;;;;

(define (menu-new widget client-data call-data)
  (display "menu-new -- not done.")
  (newline))

(define (menu-insert-ascii widget client-data call-data)
  (insert-ascii doc))

(define (menu-load-ascii widget client-data call-data)
  (load-ascii doc))

(define (menu-save-ascii widget client-data call-data)
  (save-ascii doc))

(define (menu-save-ps widget client-data call-data)
  (save-ps doc))

(define (menu-save-html widget client-data call-data)
  (save-html doc))

(define (menu-load-html widget client-data call-data)
  (load-html doc))

(define (menu-load-xword widget client-data call-data)
  (load-xword doc))

(define (menu-save-xword widget client-data call-data)
  (save-xword doc))

(define (menu-insert-img widget client-data call-data)
  (insert-img doc))

(define (menu-quit widget client-data call-data) (quit))


;;;;;;;;;;;;;;;;;;;;;;;;
;; edit menu callbacks
;;;;;;;;;;;;;;;;;;;;;;;;

(define (menu-copy-sel widget client-data call-data)
  (copy-sel))

(define (menu-clear-sel widget client-data call-data)
  (clear-selected-area))

(define (menu-cut-sel widget client-data call-data)
  (cut-sel))

(define (menu-paste-sel widget client-data call-data)
  (paste-sel))


(define (menu-copy-xcb widget client-data call-data)
  (copy-xcb))

(define (menu-paste-xcb widget client-data call-data)
  (paste-xcb))


;;;;;;;;;;;;;;;;;;;;;;;;
;; tools menu callbacks
;;;;;;;;;;;;;;;;;;;;;;;;

(define (menu-ispell widget client-data call-data)
  (run-ispell))

(define (menu-search widget client-data call-data)
  (open-search))

(define (run-top-repl widget client-data call-data)
  (display "to continue: (quit)") (newline)
  (top-repl))

(define (menu-dd widget client-data call-data)
  (display "--------------------------------------") (newline)
  (container.dd doc 1)
  (display "--------------------------------------") (newline))

(define (menu-gc-stats widget client-data call-data)
  (for-each (lambda (x) (display x) (newline)) (gc-stats)))


;;;;;;;;;;;;;;;;;;;;;;;;
;; tags menu callbacks
;;;;;;;;;;;;;;;;;;;;;;;;


(define (menu-tag-br widget client-data call-data)
  (clear-selected-area)
  (let* ((top (xword-window.insert-tag xw "<br>" cur-tag-attr)))
    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw top)))

(define (menu-tag-hr widget client-data call-data)
  (clear-selected-area)
  (let* ((top (xword-window.insert-tag xw "<hr>" cur-tag-attr)))
    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw top)))

(define (menu-tag-img widget client-data call-data)
  (insert-img doc))


;;;;;;;;;;;;;;;;;;;;;;;;;
;; scroll bar callbacks
;;;;;;;;;;;;;;;;;;;;;;;;;


(define (vsb-change widget client-data call-data)
  ;(let ((value (xt-get-value widget (xm-n-value))))
    ;(display "vsb callback: ")
    ;(display client-data)
    ;(display " ")
    ;(display value)
    ;(newline)
    ;)
  (handle-vertical-scroll-event widget xw))

(define (hsb-change widget client-data call-data)
  ;(let ((value (xt-get-value widget (xm-n-value))))
    ;(display "hsb callback: ")
    ;(display client-data)
    ;(display " ")
    ;(display value)
    ;(newline)
    ;)
  (handle-horizontal-scroll-event widget xw))


(define (draw-resize widget client-data call-data)
  (let* ((event (xt-call-data-event call-data))
         (event-elements (xt-unmangle-x-event event)))
    (if event-elements
        (begin
          ;(set! draw-width (list-ref event-elements 1))
          ;(set! draw-height (list-ref event-elements 2))
	  (display "draw-resize: ")
	  (display (list (list-ref event-elements 1)
			 (list-ref event-elements 2)))
	  (newline)))))



(define (draw-drag widget client-data event ctd)
  (let* ((event-elements (xt-unmangle-x-event event)))
    (if event-elements
	(let* ((x (cadr event-elements))
	       (y (caddr event-elements)))
	  (process-drag x y)))))

;(define (draw-expose widget client-data call-data)
;  (let* ((event (xt-call-data-event call-data))
;         (event-elements (xt-unmangle-x-event event)))
;    (if event-elements
;        (begin
;          (display "expose: ")
;	  (display (list
;		    (list-ref event-elements 1)
;		    (list-ref event-elements 2)
;		    (list-ref event-elements 3)
;		    (list-ref event-elements 4)))
;	  (newline)))))




(define (drawing-area-input widget client-data call-data)
  (let* ((event (xt-call-data-event call-data))
	 (event-elements (xt-unmangle-x-event event)))
    (if event-elements
	(cond ((eq? (car event-elements) xt-button-press)
	       (drawing-area-button widget
				    client-data
				    call-data
				    event-elements))
	      ((eq? (car event-elements) xt-key-press)
	       (drawing-area-key widget
				 client-data
				 call-data
				 event-elements))))))

  
(define (drawing-area-button widget client-data call-data event-elements)
  (let* ((x (cadr event-elements))
	 (y (caddr event-elements)))
    (process-click x y)))

(define (drawing-area-key widget client-data call-data event-elements)
  (let* ((type (list-ref event-elements 0))
	 (state (list-ref event-elements 1))
	 (keysym (list-ref event-elements 2))
	 (keycode (list-ref event-elements 3))
	 (str (list-ref event-elements 4)))
    (process-key state keysym str)))

;  (process-key (cadr event-elements) (caddr event-elements)))



(define (process-key state k str)
  ;(display "k=") (display k) (display ", ")
  ;(display "state=") (display state)
  ;(display " string='") (display str) (display "'") (newline)
  (let* ((table (key-state->table state))
	 (key-proc (assv k table)))
    (if (eqv? key-proc #f)
	((cadr (assv 0 table)) state k)
	((cadr key-proc) state k))))


(define (process-click x y)
  (xword-window.unhighlight xw)
  (xword-window.set-cursor-xy xw x y)
  (xword-window.set-mark-xy xw x y)
  (let* ((p (xword-window.get-cursor-position xw))
	 (con (car p)))
    (if (string=? (container.get-type con) "WordSegment")
	(set! cur-attr (container.get-attributes con))))
  (xword-window.scroll-to-cursor xw)
  (xword-window.redraw xw doc))


(define (process-drag x y)
  (xword-window.set-cursor-xy xw x y)
  (hl-point-to-mark))

(define (hl-point-to-mark)
  (let* ((pos0 (xword-window.get-cursor-position xw))
	 (pos1 (xword-window.get-mark-position xw)))
    (let* ((con (car pos0)))
      (if (string=? (container.get-type con) "WordSegment")
	  (set! cur-attr (container.get-attributes con))))
    (xword-window.unhighlight xw)

    (order-2-positions pos0 pos1)

    (let* ((pos0-num-ch (container.get-num-children (car pos0)))
	   (pos1-num-ch (container.get-num-children (car pos1)))
	   (hl-s (- pos0-num-ch (cadr pos0)))
	   (hl-e (- pos1-num-ch (cadr pos1)))
	   )
      (attributes.add-i highlight-start at-hl-start hl-s)
      (attributes.add-i highlight-end at-hl-end hl-e)
      (if (eqv? (car pos0) (car pos1))
	  (attributes.add-i highlight-end at-hl-start hl-s)
	  (attributes.add-i highlight-end at-hl-start pos1-num-ch))
      ;(attributes.remove-i highlight-end at-hl-start))

      (xword-window.highlight xw
			      (car pos0) (cadr pos0)
			      (car pos1) (cadr pos1)
			      highlight-start highlight highlight-end)
      (xword-window.scroll-to-cursor xw)
      (xword-window.redraw xw doc))))



;(define (set-f0 widget client-data call-data)
;  (display "set-f0") (newline)
;  (set! cur-attr (car wordsegment-styles)))

;(define (set-f1 widget client-data call-data)
;  (display "set-f1") (newline)
;  (set! cur-attr (cadr wordsegment-styles)))

;(define (set-f2 widget client-data call-data)
;  (display "set-f2") (newline)
;  (set! cur-attr (caddr wordsegment-styles)))


(define (set-page widget client-data call-data)
  ;(display "set-page: ") (display client-data) (newline)

  (let* ((col-attr (list-ref column-styles client-data))
	 (line-attr (list-ref line-styles-low client-data))
	 (word-attr (list-ref word-styles client-data))
	 (cursor (xword-window.get-cursor-position xw))
	 (wordsegment (car cursor))
	 (word (container.get-parent wordsegment))
	 (line (container.get-parent word))
	 (column (container.get-parent line))
	 (page (container.get-parent column)))
    (xword-window.set-attributes xw
				 word-attr
				 page
				 (container.find-depth word))
    (xword-window.set-attributes xw
				 line-attr
				 page
				 (container.find-depth line))
    (xword-window.set-attributes xw
				 col-attr
				 page
				 (container.find-depth column))
    (xword-window.rewrap xw
			 (container.first-lowest-container doc)
			 (container.last-lowest-container doc))
    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw doc)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; little pile of general utils
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (list-nth m ls) ; member and list
  (let* ((sub (memv m ls)))
    (if (eqv? sub #f) #f
	(- (length ls) (length sub)))))


(define (char-index str start c)
  (let* ((len (length str)))
    (do ((i start (+ i 1)))
	((or (>= i len)
	     (eqv? (string-ref str i) c))
	 (if (>= i len) #f i)))))


; parse a string with a list of args, and call execlp
(define (execlp-bleh line)
  (let* ((chop line)
	 (args
	  (do ((i (char-index chop 0 #\Space)
		  (char-index chop 0 #\Space))
	       (args (list)))
	      ((eqv? i #f) (list-append args (list chop)))
	    (set! args (list-append args (list (substring chop 0 i))))
	    (set! chop (substring chop (+ i 1) (length chop))))))
    (apply execlp (cons (car args) args))))


(define (get-point xw)
  (let ((pos (xword-window.get-cursor-position xw)))
    (if (eqv? pos #f) #f (car pos))))

(define (set-point xw c)
  (xword-window.set-cursor-position xw c 0))
  

;;;;;;;;;;;;;;;;;;;;;;;;
;; line style callback
;;;;;;;;;;;;;;;;;;;;;;;;


(define (set-line widget client-data call-data)
  (let* (
	 (cursor (xword-window.get-cursor-position xw))
	 (wordsegment (car cursor))
	 (word (container.get-parent wordsegment))
	 (line (container.get-parent word))
	 (old-attr (container.get-attributes line))
	 ;yuck
	 ; figure out if the line was latin, asian, etc
	 (line-style-index
	  (cond ((not (eqv? (list-nth old-attr line-styles-low) #f))
		 (list-nth old-attr line-styles-low))
		((not (eqv? (list-nth old-attr line-styles-high) #f))
		 (list-nth old-attr line-styles-high))
		((not (eqv? (list-nth old-attr line-styles-center) #f))
		 (list-nth old-attr line-styles-center))
		((not (eqv? (list-nth old-attr line-styles-fill) #f))
		 (list-nth old-attr line-styles-fill))))
	 (new-attr (cond ((eqv? client-data 0)
			  (list-ref line-styles-low line-style-index))
			 ((eqv? client-data 1)
			  (list-ref line-styles-high line-style-index))
			 ((eqv? client-data 2)
			  (list-ref line-styles-center line-style-index))
			 ((eqv? client-data 3)
			  (list-ref line-styles-fill line-style-index))
			 ))
	 )
    (container.set-attributes line new-attr))

  ; changing fill style shouldn't require a re-wrap.
  ;(xword-window.rewrap xw
		       ;(container.first-lowest-container doc)
		       ;(container.last-lowest-container doc))
  (xword-window.scroll-to-cursor xw)
  (xword-window.redraw xw doc))



(define (font-combo-callback widget client-data call-data)
  ;(display "font select callback: ")
  (let* ((font-name (xm-combo-box-get-string font-combo))
	 (font-size (string->number (xm-combo-box-get-string size-combo)))
	 (attr (find-wordsegment-style font-name font-size))
	 )
    ;(display font-name)
    ;(display ":")
    ;(display font-size)
    ;(newline)
    (set! cur-attr attr)
    (set-selected-area-text-attributes attr)
    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw doc)
    ))

	 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code for creating the main window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;
;; put together a window
;;;;;;;;;;;;;;;;;;;;;;;;;;

(xt-toolkit-initialize)
(define app-context (xt-create-application-context))

(define xdisplay (xt-open-display app-context #f "XWord" "XWord"))

(define xd (xdisplay.new xdisplay))

(define shell (xt-app-create-shell xdisplay "XWord"))
(define form (xt-create-widget "Form" (xm-form-widget-class) shell #f))



;;;;;;;;;;;;;;;;;;;
;; add some menus
;;;;;;;;;;;;;;;;;;;

(define menu-bar (xt-create-menu-bar form))
(xt-set-value menu-bar (xm-n-left-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-top-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-right-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-bottom-attachment) (xm-attach-none))
      
(define file-cascade
  (form-menu menu-bar "file" (list (list "load-xword" menu-load-xword #f)
				   (list "save-xword" menu-save-xword #f)
				   (list "insert-ascii" menu-insert-ascii #f)
				   (list "load-ascii" menu-load-ascii #f)
				   (list "save-ascii" menu-save-ascii #f)
				   (list "save-ps" menu-save-ps #f)
				   (list "load-html" menu-load-html #f)
				   (list "save-html" menu-save-html #f)
				   (list "insert-image" menu-insert-img #f)
				   (list "quit" menu-quit #f))))

(define edit-cascade
  (form-menu menu-bar "edit" (list ;(list "undo" menuF "menu undo")
				   (list "clear" menu-clear-sel #f)
				   (list "cut" menu-cut-sel #f)
				   (list "copy" menu-copy-sel #f)
				   (list "paste" menu-paste-sel #f)
				   )))

;(define font-cascade
;  (form-menu menu-bar "font" (list (list "F0" set-f0 #f)
;				   (list "F1" set-f1 #f)
;				   (list "F2" set-f2 #f))))

(define page-cascade
  (form-menu menu-bar "page" (list (list "latin" set-page 0)
				   (list "latin 2 Col" set-page 1)
				   (list "asian" set-page 2)
				   (list "arabic" set-page 3))))

(define line-cascade
  (form-menu menu-bar "line" (list (list "low" set-line 0)
				   (list "high" set-line 1)
				   (list "center" set-line 2)
				   (list "fill" set-line 3))))

(define tool-cascade
  (form-menu menu-bar "tools" (list (list "ispell" menu-ispell #t)
				    (list "search" menu-search #t)
				    (list "copy to xcb" menu-copy-xcb #f)
				    (list "paste from xcb"
					  menu-paste-xcb #f)
				    (list "top-repl" run-top-repl #t)
				    (list "debug-dump" menu-dd #t)
				    (list "gc-stats" menu-gc-stats #t)
				    )))

(define tag-cascade
  (form-menu menu-bar "tags" (list (list "<br>" menu-tag-br #t)
				   (list "<hr>" menu-tag-hr #t)
				   (list "<img>" menu-tag-img #t)
				   )))

;;;;;;;;;;;;;;;;
;; scroll bars
;;;;;;;;;;;;;;;;

(define vsb (xt-create-widget "vsb" (xm-scroll-bar-widget-class) form 
			      (list
			       (list (xm-n-maximum) 1000)
			       (list (xm-n-slider-size) 100)
			       )
			      ))
(xt-set-value vsb (xm-n-orientation) (xm-vertical))
(xt-set-value vsb (xm-n-left-attachment) (xm-attach-none))
(xt-set-value vsb (xm-n-top-attachment) (xm-attach-widget))
(xt-set-value vsb (xm-n-top-widget) menu-bar)
(xt-set-value vsb (xm-n-right-attachment) (xm-attach-form))
(xt-set-value vsb (xm-n-bottom-attachment) (xm-attach-form))

(xt-add-callback vsb (xm-n-value-changed-callback) vsb-change '("value"))
(xt-add-callback vsb (xm-n-drag-callback) vsb-change '("drag"))
(xt-add-callback vsb (xm-n-increment-callback) vsb-change '("inc"))
(xt-add-callback vsb (xm-n-page-increment-callback) vsb-change '("page inc"))
(xt-add-callback vsb (xm-n-decrement-callback) vsb-change '("dec"))
(xt-add-callback vsb (xm-n-page-decrement-callback) vsb-change '("page dec"))


(define hsb
  (xt-create-widget "hsb" (xm-scroll-bar-widget-class) form 
		    (list (list (xm-n-orientation) (xm-horizontal))
			  (list (xm-n-left-attachment) (xm-attach-form))
			  (list (xm-n-top-attachment) (xm-attach-none))
			  (list (xm-n-right-attachment) (xm-attach-widget))
			  (list (xm-n-right-widget) vsb)
			  (list (xm-n-bottom-attachment) (xm-attach-form)))))

(xt-add-callback hsb (xm-n-value-changed-callback) hsb-change '("value"))
(xt-add-callback hsb (xm-n-drag-callback) hsb-change '("drag"))
(xt-add-callback hsb (xm-n-increment-callback) hsb-change '("inc"))
(xt-add-callback hsb (xm-n-page-increment-callback) hsb-change '("page inc"))
(xt-add-callback hsb (xm-n-decrement-callback) hsb-change '("dec"))
(xt-add-callback hsb (xm-n-page-decrement-callback) hsb-change '("page dec"))


(define scroll-x 0)
(define scroll-y 0)


;;;;;;;;;;;;;
;; tool bar
;;;;;;;;;;;;;

(define tool-rc (xt-create-widget "tool-rc"
				  (xm-row-column-widget-class) form #f))

;(xt-set-value tool-rc (xm-n-num-columns) 2)
(xt-set-value tool-rc (xm-n-orientation) (xm-horizontal))
(xt-set-value tool-rc (xm-n-left-attachment) (xm-attach-form))
(xt-set-value tool-rc (xm-n-top-attachment) (xm-attach-widget))
(xt-set-value tool-rc (xm-n-top-widget) menu-bar)
(xt-set-value tool-rc (xm-n-right-attachment) (xm-attach-widget))
(xt-set-value tool-rc (xm-n-right-widget) vsb)
(xt-set-value tool-rc (xm-n-bottom-attachment) (xm-attach-none))

;;;;;;;;;;;;;;;;
;; font combos
;;;;;;;;;;;;;;;;

(if combos-on
    (begin
      (define font-combo (xt-create-widget
			  "font-combo"
			  (xm-combo-box-widget-class)
			  tool-rc
			  ;(list
			   ;(list (xm-n-visible-item-count) 7)
			   ;(list (xm-n-scroll-bar-display-policy) (xm-static))
			  ;)
			  #f
			  ))
      (define size-combo (xt-create-widget "size-combo"
					   (xm-combo-box-widget-class)
					   tool-rc #f))


      (xt-add-callback font-combo
		       (xm-n-selection-callback)
		       font-combo-callback (list #f))
      (xt-add-callback size-combo
		       (xm-n-selection-callback)
		       font-combo-callback (list #f))


      (let* ((filename (find-the-file "font_config")))
	(if (eqv? filename #f)
	    (begin
	      (display "couldn't find font_config.")(newline)
	      (add-combo-box-item font-combo "Courier"))
	    (let* ((fp (open-file filename "r")))
	      (do ((input-line (read-line fp 'concat) (read-line fp 'concat)))
		  ((eof-object? input-line) #t)
		(let* ((spc-pos (char-index input-line 0 #\Space))
		       (tab-pos (char-index input-line 0 #\011))
		       (pos 0)
		       )
		  (if (eqv? spc-pos #f)
		      (if (eqv? tab-pos #f)
			  (begin (display "bogus font_config line?") (newline))
			  (set! pos tab-pos))
		      (if (eqv? tab-pos #f)
			  (set! pos spc-pos)
			  (set! pos (min tab-pos spc-pos))))
		  (add-combo-box-item font-combo (substring input-line 0 pos))
		  )
		)
	      (close-input-port fp))))
	     


      (add-combo-box-item size-combo "6")
      (add-combo-box-item size-combo "8")
      (add-combo-box-item size-combo "10")
      (add-combo-box-item size-combo "12")
      (add-combo-box-item size-combo "13")
      (add-combo-box-item size-combo "14")
      (add-combo-box-item size-combo "15")
      (add-combo-box-item size-combo "16")
      (add-combo-box-item size-combo "20")
      (add-combo-box-item size-combo "24")
      (add-combo-box-item size-combo "48")

      (xm-combo-box-select-position font-combo 1)
      (xm-combo-box-select-position size-combo 2)
      ))


;;;;;;;;;;;;;;;;;
;; drawing area
;;;;;;;;;;;;;;;;;

(define draw-width (* magnify 432))
(define draw-height 400)


(define draw (xt-create-widget "draw" (xm-drawing-area-widget-class) form #f))
(xt-set-value draw (xt-n-width) draw-width)
(xt-set-value draw (xt-n-height) draw-height)
(xt-set-value draw (xm-n-left-attachment) (xm-attach-form))
(xt-set-value draw (xm-n-top-attachment) (xm-attach-widget))
;(xt-set-value draw (xm-n-top-widget) menu-bar)
(xt-set-value draw (xm-n-top-widget) tool-rc)
(xt-set-value draw (xm-n-right-attachment) (xm-attach-widget))
(xt-set-value draw (xm-n-right-widget) vsb)
(xt-set-value draw (xm-n-bottom-attachment) (xm-attach-widget))
(xt-set-value draw (xm-n-bottom-widget) hsb)

;(xt-add-callback draw (xm-n-expose-callback) draw-expose (list #f))
(xt-add-callback draw (xm-n-input-callback) drawing-area-input (list #f))
(xt-add-callback draw (xm-n-resize-callback) draw-resize (list #f))
(xt-add-event-handler draw xt-button1-motion-mask #f draw-drag (list #f))


;;;;;;;;;;;;;;;;;;;;;;;
;; file selection box
;;;;;;;;;;;;;;;;;;;;;;;

(define fsb-shell #f)
(define fsb #f)

(define (show-fsb)
  (if (eqv? fsb-shell #f)
      (begin
	(set! fsb-shell
	      (xt-app-create-shell xdisplay "XWord File Selection"))
	(set! fsb (xt-create-widget "fsb"
				    (xm-file-selection-box-widget-class)
				    fsb-shell
				    (list (list
					   (xm-n-dialog-type)
					   (xm-dialog-file-selection)))))

	(xt-manage-child fsb)
	(xt-realize-widget fsb-shell)
	(xt-popup fsb-shell (xt-grab-none)))
      ;else
      (xt-popup fsb-shell (xt-grab-none)))
  fsb)


(define (fsb-get-file-name widget)
  (let* ((dir-spec (xt-get-value widget (xm-n-dir-spec))))
    (xm-string-get-l-to-r dir-spec (xm-font-list-default-tag))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; work around a bug? in lesstif where
;;   the cascade buttons get keypresses that
;;   should have gone to the drawing area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(xt-set-keyboard-focus file-cascade draw)
(xt-set-keyboard-focus edit-cascade draw)
;(xt-set-keyboard-focus font-cascade draw)
(xt-set-keyboard-focus page-cascade draw)
(xt-set-keyboard-focus line-cascade draw)
(xt-set-keyboard-focus tool-cascade draw)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; and fix other key grabbers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(if combos-on
    (begin
      (xt-set-keyboard-focus (xt-name-to-widget font-combo "edit") draw)
      (xt-set-keyboard-focus (xt-name-to-widget size-combo "edit") draw)
      ))


;;;;;;;;;;;;;;;;;;;;;;;;
;; manage and realize
;;;;;;;;;;;;;;;;;;;;;;;;


(xt-manage-child menu-bar)
(if combos-on
    (begin
      (xt-manage-child font-combo)
      (xt-manage-child size-combo)
      ))
(xt-manage-child tool-rc)
(xt-manage-child draw)
(xt-manage-child vsb)
(xt-manage-child hsb)
(xt-manage-child form)
(xt-realize-widget shell)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; get common X variables ready
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;
;(define xdisplay (xt-display draw))
;;

(define drawable (xt-window draw))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start up the XWord-Window class
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;
;(define xd (xdisplay.new xdisplay))
;;

(define fm (xdisplay.get-fm xd))
(fontmanager.set-display-scale fm magnify)
(fontmanager.loadFonts fm)
(define xcb (xcutbuffer.new xdisplay))
(define doc (create-empty-doc xd))
(define xw (create-xword-window-content xd draw vsb hsb doc))

(xword-window.set-paste-attributes xw cur-attr cur-tag-attr)

(xt-app-main-loop app-context)
